/*	Dio.java
 *
 *	Example of Digital I/O for PCI-TMC12
 *
 *	v 0.0 2003.8.7 by moki matsushima
 *
 *	Copyright (c) 2003 ICPDAS, Inc. All  Rights Reserved.
 */
 
import java.io.*;							//For System.in.read()
import com.icpdas.cardio.ixpci.*;					//ICPDAS PCI Series I/O Card packages

public class Dio 
{
	public static void main(String[] args) throws java.io.IOException
	{
		int rev;
		int fd;
		int rdi=0;
		byte a[] = new byte[100];
		byte b;
		Ixpci icpdasio1=new Ixpci();
		IxpciReg rdo = new IxpciReg();
		rdo.value = 1;
		fd=icpdasio1.open("ixpci1");
		if(fd==-1) System.out.println("Card Open Error Code:"+ fd);
		while(a[0]!=113)
		{
			/* DO */
			if((rev=icpdasio1.setReg(fd,"IXPCI_DO",rdo))!=0) System.out.println("Failure of icotal command IXPCI_DO error code:"+ rev);
			System.out.println("DO = "+Integer.toHexString(rdo.value)); 
			/* DI */
			if((rdi=icpdasio1.getReg(fd,"IXPCI_DI"))==-1) System.out.println("Failure of ioctl command IXPCI_DI Error Code:"+ rdi);
			System.out.println("DI = "+Integer.toHexString(rdi)); 
			System.in.read(a);
			rdo.value = (rdo.value == 0x8000) ? 1 : (rdo.value<<1);
		}
		icpdasio1.close(fd);
		System.out.println("End of program");		
	}

}
