/*	Dio2.java
 *
 *	Example of Digital I/O for PCI-1202
 *
 *	v 0.0 2003.8.7 by moki matsushima
 *
 *	Copyright (c) 2003 ICPDAS, Inc. All  Rights Reserved.
 */
 
import java.io.*;							//For System.in.read()
import com.icpdas.cardio.ixpci.*;					//ICPDAS PCI Series I/O Card packages

public class Dio2 
{
	public static void main(String[] args) throws java.io.IOException
	{
		int rev;
		int fd;
		IxpciDio dout = new IxpciDio();
		IxpciDio din = new IxpciDio();
		byte a[] = new byte[100];
		Ixpci icpdasio1=new Ixpci();
		fd=icpdasio1.open("ixpio2");
		if(fd==-1) System.out.println("Card Open Error Code:"+ fd);
		dout.u16 = 1 ;
		din.u16 = 0;
		System.out.println("Press <enter> for next, 'q'+<enter> to exit.");
		while(a[0]!=113)
		{
			/* DO */
			if((rev=icpdasio1.setDigitalOut(fd,dout))!=0) System.out.println("DigitalOut Error Code:"+ rev);
			/* DI */
			if((rev=icpdasio1.getDigitalIn(fd,din))!=0) System.out.println("DigitalIn Error Code:"+ rev);

			System.out.println("Digital Output: 0x"+ Integer.toHexString(dout.u16) +"    Input: 0x"+ Integer.toHexString(din.u16)+"     <Enter> next, 'q'+<enter> exit ");
			System.in.read(a);
			if(dout.u16 == 0x8000){
				dout.u16 = 1 ;
			}else dout.u16 <<= 1;
		}
		icpdasio1.close(fd);
		System.out.println("End of program");		
	}

}
