/*	Port.java
 *
 *	Example of I/O port for PIO-D24.
 *
 *	v 0.0 2003.8.7 by moki matsushima
 *
 *	Copyright (c) 2003 ICPDAS, Inc. All  Rights Reserved.
 */
 
import java.io.*;							//For System.in.read()
import com.icpdas.cardio.ixpio.*;					//ICPDAS PIO Series I/O Card packages

public class Port 
{
	public static void main(String[] args) throws java.io.IOException
	{
		int rev;
		int fd;
		int port0=0,port1=0,port2=1;
		byte a[] = new byte[100];
		Ixpio icpdasio1=new Ixpio();
		IxpioReg rdo = new IxpioReg();
		fd=icpdasio1.open("ixpio1");
		if(fd==-1) System.out.println("Card Open Error Code:"+ fd);
		/* 	setup I/O Selection Control Register
	   		Port 0,1 as input port
	   		Port 2 as output port 			*/		
		rev=icpdasio1.setPort(fd,"IXPIO_PC",04);	
		/* write Port2, read Port0, Port1 */
		if(rev!=0) System.out.println("Configure Port Error Code:"+ rev);
		rdo.value = port2;
		while(a[0]!=113)	/* read, get out if 'q' + Enter pressed */
		{
			if((rev=icpdasio1.setReg(fd,"IXPIO_P2",rdo))!=0) System.out.println("Write P2 Error Code:"+ rev);
			if((port0=icpdasio1.getReg(fd,"IXPIO_P0"))==-1) System.out.println("Read P0 Error Code:"+ port0);
			if((port1=icpdasio1.getReg(fd,"IXPIO_P1"))==-1) System.out.println("Read P1 Error Code:"+ port1);
			System.out.println("Port0="+ port0 +" Port1="+ port1 +" Port2="+ port2); 
			System.in.read(a);
			port2 = (port2 == 8) ? 1 : (port2<<1);
			rdo.value = port2;
		}
		icpdasio1.close(fd);
		System.out.println("End of program");		
	}

}
