/*	Counter.java
 *
 *	Example of counter for PIO-D48.
 *
 *	v 0.0 2003.8.7 by moki matsushima
 *
 *	Copyright (c) 2003 ICPDAS, Inc. All  Rights Reserved.
 */
 
import java.io.*;							//For System.in.read()
import com.icpdas.cardio.ixpio.*;					//ICPDAS PIO Series I/O Card packages


public class Counter implements IxpioIsr 				//Implement IxpioIsr interrupt class
{
	static int beat = 0;
	static int INT1 = 2;
	static int INT1_NEG_EDGE = 0;
	static IxpioDio din,dout;
	static Ixpio icpdasio1;
	static int fd;
	public void ixpio_isr(int sig)					//Will be call when trigger interrupt
	{
		//System.out.println("Get Int");
		
		int rev;
		if ((rev=icpdasio1.setDigitalOut(fd,dout))!=0) System.out.println("DO Error");
		if ((rev=icpdasio1.getDigitalIn(fd,din))!=0) System.out.println("DO Error");
		System.out.print("\rTime beat: "+ beat + "   Digital Output: 0x"+ Integer.toHexString(dout.u16)+ "   Digital Input: 0x"+ Integer.toHexString(din.u16)+ "    <enter> exit");
		if (dout.u16 == 0x8000) dout.u16 = 1;
		else dout.u16 <<=1 ;
		beat ++;
	}
	
	public static void main(String[] args) throws java.io.IOException
	{
		int rev;
		Counter demo_isr;
		byte a[] = new byte[100];
		icpdasio1 = new Ixpio();
		din = new IxpioDio();
		dout = new IxpioDio();
		fd=icpdasio1.open("ixpio1");
		if(fd==-1) System.out.println("Card Open Error Code:"+ fd);
		din.u16 = 0;
		dout.u16 = 1;
		demo_isr = new Counter();
		/* INT_CHAN_3 signal for negative edge */
		rev=icpdasio1.registerInterrupt(fd, INT1, INT1_NEG_EDGE, demo_isr);  
		if(rev != 0) System.out.println("Install Interrupt Error Code:"+ rev);
		/*****************************************
	 	* setup 8254 counter-1/2 for INT_CHAN_3 *
	 	*                                       *
	 	* 32768Hz / (0x4000 * 2) = 1Hz          *
	 	*****************************************/	
	 	/* counter-1, 0x76 = mode 3, 15 = 32768Hz */
		rev=icpdasio1.setCounter(fd,1,15,0x76,0x4000);	
		if(rev != 0) System.out.println("Config Counter 1 Error Code:"+ rev);
		/* counter-2, 0xb6 = mode 3, 15 = 32768Hz */
		rev=icpdasio1.setCounter(fd,2,15,0xb6,2);	
		if(rev != 0) System.out.println("Config Counter 2Error Code:"+ rev);
		while(a[0]!=113)
		{
			System.in.read(a); 
		}
		rev=icpdasio1.removeInterrupt(fd);   /* INT_CHAN_0  signal for both edges */
		if(rev != 0) System.out.println("Remove Interrupt Error Code:"+ rev);
		icpdasio1.close(fd);
		System.out.println("End of program");
	}
}
