/*	Interrupt.java
 *
 *	Example of interrupt for PIO-D48.
 *
 *	v 0.0 2003.8.7 by moki matsushima
 *
 *	Copyright (c) 2003 ICPDAS, Inc. All  Rights Reserved.
 */
 
import java.io.*;							//For System.in.read()
import com.icpdas.cardio.ixpio.*;					//ICPDAS PIO Series I/O Card packages


public class Interrupt implements IxpioIsr  				//Implement IxpioIsr interrupt class
{
	
	public void ixpio_isr(int sig)					//Will be call when trigger interrupt
	{
		System.out.println("Java get signal " + sig);
	}
	
	public static void main(String[] args) throws java.io.IOException
	{
		int rev;
		int fd;
		Interrupt demo_isr;
		byte a[] = new byte[100];
		Ixpio icpdasio1=new Ixpio();
		fd=icpdasio1.open("ixpio1");
		if(fd==-1) System.out.println("Card Open Error Code:"+ fd);
		/* PA and PC as input port */
		if((rev=icpdasio1.setPort(fd,"IXPIO_82551CW",0x99))!=0) System.out.println("Configure 8255 Error Code:"+ rev);    // Port 0/1 as DO, Port 2 as DI 
		/* INT_CHAN_0 = PC3 of port 2 INT_CHAN_1 = * PC3&!PC& of port 2 */
		rev=icpdasio1.setCounter(fd,1,0x08,0x76,0x4000);	
		if(rev != 0) System.out.println("Config Clock Error Code:"+ rev);
		demo_isr = new Interrupt();
		/* INT_CHAN_0  signal for both edges */
		if((rev=icpdasio1.registerInterrupt(fd, 1, 2,demo_isr))!=0) System.out.println("Reg Int Error Code : "+ rev);
		while(a[0]!=113)
		{
			System.in.read(a);
		}
		/*Remove Interrupt before program end*/
		if((rev=icpdasio1.removeInterrupt(fd))!=0) System.out.println("Remove Int Error Code : "+ rev);
		icpdasio1.close(fd);
		System.out.println("End of program");
	}
}
