/*	Port.java
 *
 *	Example of I/O reg for PIO-D96.
 *
 *	v 0.0 2003.8.7 by moki matsushima
 *
 *	Copyright (c) 2003 ICPDAS, Inc. All  Rights Reserved.
 */
 
import java.io.*;							//For System.in.read()
import com.icpdas.cardio.ixpio.*;					//ICPDAS PIO Series I/O Card packages

public class Port 
{
	public static void main(String[] args) throws java.io.IOException
	{
		int rev;
		int fd;
		int port6=0,port7=0,port8=0,port9=0,port10=0,port11=0;
		IxpioReg port3 = new IxpioReg();
		IxpioReg port4 = new IxpioReg();
		IxpioReg port5 = new IxpioReg();
		port3.value = 1;
		port4.value = 4;
		port5.value = 16;
		byte a[] = new byte[100];
		Ixpio icpdasio1=new Ixpio();
		fd=icpdasio1.open("ixpio2");
		if(fd==-1) System.out.println("Card Open Error Code:"+ fd);
		/* configure ports */
		//port3-5 as output*/
		if((rev=icpdasio1.setPort(fd,"IXPIO_PCB",07))!=0) System.out.println("Configure Port Error Code:"+ rev);
		/*port 6-8 as input*/
		if((rev=icpdasio1.setPort(fd,"IXPIO_PCC",0))!=0) System.out.println("Configure Port Error Code:"+ rev);
		/*port 9~11 as input*/
		if((rev=icpdasio1.setPort(fd,"IXPIO_PCD",0))!=0) System.out.println("Configure Port Error Code:"+ rev);
		System.out.println("     +----DI----+  +----DI----+  +----DO----+");
		System.out.println("     |          |  |          |  |          |");
		System.out.println("Port  11  10   9     8   7   6     5   4   3");
		System.out.println("      --  --  --    --  --  --    --  --  --");
		while(a[0]!=113)
		{
			if((rev=icpdasio1.setReg(fd,"IXPIO_P3",port3))!=0) System.out.println("Write P3 Error Code:"+ rev);
			if((rev=icpdasio1.setReg(fd,"IXPIO_P4",port4))!=0) System.out.println("Write P4 Error Code:"+ rev);
			if((rev=icpdasio1.setReg(fd,"IXPIO_P5",port5))!=0) System.out.println("Write P5 Error Code:"+ rev);
			if((port6=icpdasio1.getReg(fd,"IXPIO_P6"))==-1) System.out.println("Read P6 Error Code:"+ port6);
			if((port7=icpdasio1.getReg(fd,"IXPIO_P7"))==-1) System.out.println("Read P7 Error Code:"+ port7);
			if((port8=icpdasio1.getReg(fd,"IXPIO_P8"))==-1) System.out.println("Read P8 Error Code:"+ port8);
			if((port9=icpdasio1.getReg(fd,"IXPIO_P9"))==-1) System.out.println("Read P9 Error Code:"+ port9);
			if((port10=icpdasio1.getReg(fd,"IXPIO_P10"))==-1) System.out.println("Read P10 Error Code:"+ port10); 
			if((port11=icpdasio1.getReg(fd,"IXPIO_P11"))==-1) System.out.println("Read P11 Error Code:"+ port11);	
			System.out.println("      " + Integer.toHexString(port11) + "  " + Integer.toHexString(port10) + "  " + Integer.toHexString(port9) + "    " + Integer.toHexString(port8) + "  " + Integer.toHexString(port7) + "  " + Integer.toHexString(port6) + "    " + Integer.toHexString(port5.value) + "  " + Integer.toHexString(port4.value) + "  " + Integer.toHexString(port3.value) ); 
			System.in.read(a);
			port3.value = (port3.value > 80 ) ? 1 : (port3.value << 1);
			port4.value = (port4.value > 80 ) ? 1 : (port4.value << 1);
			port5.value = (port5.value > 80 ) ? 1 : (port5.value << 1);
		}
		icpdasio1.close(fd);
		System.out.println("End of program");
	}

}
